wreport::bufr::CompressedDecoderTarget Struct Reference
Inheritance diagram for wreport::bufr::CompressedDecoderTarget:

## Public Member Functions

| CompressedDecoderTarget (Input &in, Bulletin &out)
const Subset & | reference_subset () const override
| Return the reference to a subset that is receiving the data currently decoded.
Varinfo | lookup_info (unsigned pos) const override
| Return information about a value previously stored at the given position.
Var | decode_uniform_b_value (Varinfo info) override
| Decode a value that must always be the same across all datasets.
const Var & | decode_and_add_to_all (Varinfo info) override
| Decode and add the same value to all datasets, return a reference to one of the variables added.
const Var & | decode_and_add_bitmap (const Tables &tables, Varcode code, unsigned bitmap_size) override
void | decode_and_set_attribute (Varinfo info, unsigned pos) override
| Decode an attribute with the given description, and add it to data at position pos.
void | decode_and_add_b_value (Varinfo info) override
| Decode a B-table value and add its value(s) to the target subset(s).
void | decode_and_add_b_value_with_associated_field (Varinfo info, const bulletin::AssociatedField &field) override
| Decode a B-table value with associated field, and add its value(s) to the target subset(s).
void | decode_and_add_raw_character_data (Varinfo info) override
| Decode raw character data described by code and add it to the target subset(s).
int | decode_c03_refval_override (unsigned bits) override
| Decode the given number of bits a signed integer, to use as a new value for B table reference value.
void | print_last_variable_added (FILE *out) override
| Print the value(s) of the last variable(s) added to out.
void | print_last_attribute_added (FILE *out, Varcode code, unsigned pos) override
| Print the value(s) of the last attributes(s) with the given code added to out.
Public Member Functions inherited from wreport::bufr::DecoderTarget
| DecoderTarget (Input &in)

## Data Fields

Bulletin & | out
| Output bulletin.
unsigned | subset_count
| Number of subsets in data section.
Data Fields inherited from wreport::bufr::DecoderTarget
Input & | in
| Input buffer.

## Protected Member Functions

void | decode_b_value (Varinfo info, std::function< void(unsigned, Var &&)> dest)

## Member Function Documentation

## decode_and_add_b_value()

void wreport::bufr::CompressedDecoderTarget::decode_and_add_b_value | ( | Varinfo | info | ) |

override virtual

Decode a B-table value and add its value(s) to the target subset(s).

Implements wreport::bufr::DecoderTarget.

## decode_and_add_b_value_with_associated_field()

void wreport::bufr::CompressedDecoderTarget::decode_and_add_b_value_with_associated_field | ( | Varinfo | info,
|  | const bulletin::AssociatedField & | field )

override virtual

Decode a B-table value with associated field, and add its value(s) to the target subset(s).

Implements wreport::bufr::DecoderTarget.

## decode_and_add_bitmap()

const Var & wreport::bufr::CompressedDecoderTarget::decode_and_add_bitmap | ( | const Tables & | tables,
|  | Varcode | code,
|  | unsigned | bitmap_size )

override virtual

Implements wreport::bufr::DecoderTarget.

## decode_and_add_raw_character_data()

void wreport::bufr::CompressedDecoderTarget::decode_and_add_raw_character_data | ( | Varinfo | info | ) |

override virtual

Decode raw character data described by code and add it to the target subset(s).

Implements wreport::bufr::DecoderTarget.

## decode_and_add_to_all()

const Var & wreport::bufr::CompressedDecoderTarget::decode_and_add_to_all | ( | Varinfo | info | ) |

override virtual

Decode and add the same value to all datasets, return a reference to one of the variables added.

Implements wreport::bufr::DecoderTarget.

## decode_and_set_attribute()

void wreport::bufr::CompressedDecoderTarget::decode_and_set_attribute | ( | Varinfo | info,
|  | unsigned | pos )

override virtual

Decode an attribute with the given description, and add it to data at position pos.

Implements wreport::bufr::DecoderTarget.

## decode_c03_refval_override()

int wreport::bufr::CompressedDecoderTarget::decode_c03_refval_override | ( | unsigned | bits | ) |

override virtual

Decode the given number of bits a signed integer, to use as a new value for B table reference value.

Implements wreport::bufr::DecoderTarget.

## decode_uniform_b_value()

Var wreport::bufr::CompressedDecoderTarget::decode_uniform_b_value | ( | Varinfo | info | ) |

override virtual

Decode a value that must always be the same across all datasets.

Do not add it to the output.

Returns
  the decoded value

Implements wreport::bufr::DecoderTarget.

## lookup_info()

Varinfo wreport::bufr::CompressedDecoderTarget::lookup_info | ( | unsigned | pos | ) | const

override virtual

Return information about a value previously stored at the given position.

Implements wreport::bufr::DecoderTarget.

## print_last_attribute_added()

void wreport::bufr::CompressedDecoderTarget::print_last_attribute_added | ( | FILE * | out,
|  | Varcode | code,
|  | unsigned | pos )

override virtual

Print the value(s) of the last attributes(s) with the given code added to out.

Implements wreport::bufr::DecoderTarget.

References out.

## print_last_variable_added()

void wreport::bufr::CompressedDecoderTarget::print_last_variable_added | ( | FILE * | out | ) |

override virtual

Print the value(s) of the last variable(s) added to out.

Implements wreport::bufr::DecoderTarget.

References out.

## reference_subset()

const Subset & wreport::bufr::CompressedDecoderTarget::reference_subset | ( |  | ) | const

override virtual

Return the reference to a subset that is receiving the data currently decoded.

For uncompressed decoders, this is the current subset. For compressed decoders, it is the first subset.

Implements wreport::bufr::DecoderTarget.

The documentation for this struct was generated from the following file:

- decoder.h